#!/bin/sh
#Created by Vasiliks 07.11.2014
LABEL_FROM=$1 ; PART_FROM=$2
LABEL_TO=$3 ; PART_TO=$4
DIRECTORY=/media/hdd
LANG='en'
if grep -qs 'config.osd.language=ru_RU' /etc/enigma2/settings ; then LANG='ru' ; fi   
MESSAGE(){ if [ $LANG = "ru" ]; then echo "$2"; else echo "$1"; fi }

umount -l "$PART_TO"  2>/dev/null
rm -rf $DIRECTORY/tmp/from
mkdir -p $DIRECTORY/tmp/from
rm -rf $DIRECTORY/tmp/copy
mkdir -p $DIRECTORY/tmp/copy

if  [[ "$LABEL_FROM" = "NAND" ]] ; then
  mount -t jffs2 /dev/mtdblock6 $DIRECTORY/tmp/from
else
  mount $PART_FROM $DIRECTORY/tmp/from
fi
MESSAGE "Partition $LABEL_FROM mounted\n" "Раздел $LABEL_FROM примонтирован\n"

if  [[ "$LABEL_TO" = "NAND" ]] ; then
  flash_eraseall -jq /dev/mtd6
  flash_erase /dev/mtd5 0x000000 0x20 2>&1 | tee >/dev/null
  nandwrite  -p  /dev/mtd5 $DIRECTORY/tmp/from/boot/uImage 2>&1 | tee >/dev/null
  mount -t jffs2 /dev/mtdblock6 $DIRECTORY/tmp/copy
else
  LABEL_TO=`echo $4 | sed "s;/dev/sd;PART;"`
  /sbin/tune2fs -L $LABEL_TO $4 2>&1 | tee >/dev/null
  MESSAGE "Partition $3 renamed to $LABEL_TO\n" "Раздел $3 переименован в $LABEL_TO\n"
  mount $PART_TO $DIRECTORY/tmp/copy
  rm -rf $DIRECTORY/tmp/copy/*
fi
MESSAGE "Partition $LABEL_TO mounted\n" "Раздел $LABEL_TO примонтирован\n"

if [[ "$5" = "YES" ]]; then
  mv $DIRECTORY/tmp/from/etc/enigma2/settings $DIRECTORY/tmp
  MESSAGE "Enigma2 settings deleted" "Файл настроек Enigma2 settings удален"
fi

MESSAGE "Please wait, there is a copying" "Пожалуйста подождите, идет копирование"
MESSAGE "of the partition $LABEL_FROM for $LABEL_TO partition\n" "с раздела $LABEL_FROM на раздел $LABEL_TO\n"

(cd $DIRECTORY/tmp/from && tar cf - .) | (cd $DIRECTORY/tmp/copy && tar xf -)

if [[ "$5" = "YES" ]]; then
  mv $DIRECTORY/tmp/settings $DIRECTORY/tmp/from/etc/enigma2
fi

cd /
sync
sleep 5
umount $DIRECTORY/tmp/copy
MESSAGE "Partition $LABEL_FROM unmounted\n" "Раздел $LABEL_FROM отмонтирован\n"
umount $DIRECTORY/tmp/from
MESSAGE "Partition $LABEL_TO unmounted\n" "Раздел $LABEL_TO отмонтирован\n"
rm -rf $DIRECTORY/tmp
exit
