import os, sys, os.path
import re
import gettext
from os import environ
from enigma import eTimer, eEnv
from enigma import addFont
from enigma import ePicLoad, loadPNG, getDesktop
from Plugins.Plugin import PluginDescriptor
from Components.MenuList import MenuList
from Components.ActionMap import ActionMap
from Components.config import getConfigListEntry, ConfigText, ConfigClock, ConfigYesNo, ConfigLocations, ConfigSubsection, ConfigSelection, config, configfile
from Components.ConfigList import ConfigListScreen
from Tools.Directories import resolveFilename, SCOPE_PLUGINS, SCOPE_LANGUAGE
from Components.Sources.StaticText import StaticText
from Components.Language import language
from Components.Sources.List import List
from Screens.MessageBox import MessageBox
from Components.Label import Label
from skin import loadSkin
from Components.Console import Console as iConsole
from Screens.Screen import Screen
from Components.ScrollLabel import ScrollLabel
from GlobalActions import globalActionMap
from datetime import datetime
from time import time
import urllib, urllib2
from Components.Pixmap import Pixmap, MovingPixmap
from twisted.web.client import downloadPage, getPage, error

PLUGIN_PATH = '/usr/lib/enigma2/python/Plugins/Extensions/SpeedTest'
loadSkin(PLUGIN_PATH + '/skin.xml')
data_dir = '/tmp/'
file_name = 'speedtest.log'

try:
    addFont('%s/MyriadPro-Regular.otf' % PLUGIN_PATH, 'RegularIPTV', 100, 1)
    print 'added'
except Exception as ex:
    print ex
	
class speedtest(Screen):

	def __init__(self, session):
		self.session = session
		Screen.__init__(self, session)
		self.iConsole = iConsole()
		self["key_red"] = StaticText(_("Exit"))
		self["key_green"] = StaticText(_("Start"))
		self["provider"] = Label("")
		self["server"] = Label("")
		self["km"] = Label("")
		self["ping"] = Label("")
		self["download"] = Label("")
		self["upload"] = Label("")
		# self['coverArt'] = Pixmap()
		# self.picload = ePicLoad()
		# self.picfile = ''
		self["setupActions"] = ActionMap(["SetupActions", "ColorActions"],
		{
			"red": self.cancel,
			"cancel": self.cancel,
			"green": self.start,
		}, -2)
		self.onShow.append(self.listuserbouquet)
		
	def start(self):
		self.session.openWithCallback(self.info, test)
		
	def info(self):
		if os.path.isfile('%s%s' % (data_dir, file_name)):
			f = open('%s%s' % (data_dir, file_name)).read()
			print f
			regex = re.findall('Testing from (.*?) \(.*?\s.*?\sHosted by (.*?) \[(.*?)\]: (.*?) ms\s.*?\sDownload: (.*?)\s.*?\sUpload: (.*?)\sShare results: (.*?)png', f)
			print regex
			for text in regex:
				print text[0], text[1], text[2], text[3], text[4], text[5]
				self["provider"].setText(text[0])
				self["server"].setText(text[1])
				self["km"].setText(text[2])
				self["ping"].setText(text[3])
				self["download"].setText(text[4])
				self["upload"].setText(text[5])
				# poster = text[6] + 'png'
				# self.Read(poster)

	# def Read(self, poster):
		# self.poster = poster
		# downloadPage(poster, '/tmp/poster.jpg').addCallback(self.ptCoverShow)

	# def ptCoverShow(self, picData):
		# if fileExists('/tmp/poster.jpg'):
			# self['coverArt'].instance.setPixmap(None)
			# self.scale = AVSwitch().getFramebufferScale()
			# self.picload = ePicLoad()
			# size = self['coverArt'].instance.size()
			# self.picload.setPara((size.width(),
			# size.height(),
			# self.scale[0],
			# self.scale[1],
			# False,
			# 1,
			# '#FF000000'))
			# if self.picload.startDecode('/tmp/poster.jpg', 0, 0, False) == 0:
				# ptr = self.picload.getData()
				# if ptr != None:
					# self['coverArt'].instance.setPixmap(ptr.__deref__())
					# self['coverArt'].show()
					# del self.picload
		# return
		
	def listuserbouquet(self):
		self.setTitle(_("SpeedTest"))
		
	def cancel(self):
		self.close(False)


skin_wait = """
<screen name="waiting" position="center,140" size="625,100" title="Please wait">
  <widget source="status" render="Label" position="10,5" size="605,32" zPosition="2" font="Regular; 30" halign="center" transparent="2" />
</screen>"""

class test(Screen):
	def __init__(self, session, args=None):
		Screen.__init__(self, session)
		self.session = session
		self.skin = skin_wait
		self.setTitle(_("Please wait"))
		self["status"] = StaticText()
		self.iConsole = iConsole()
		self["status"].text = _("Please wait")
		self["setupActions"] = ActionMap(["SetupActions", "ColorActions"],
		{
			"red": self.cancel,
			"cancel": self.cancel,
		}, -2)
		self.iConsole.ePopen("/usr/lib/enigma2/python/Plugins/Extensions/SpeedTest/speedtest_cli.py --share > /tmp/speedtest.log", self.end)
	
	def end(self, result, retval, extra_args):
		self.close()
		
	def cancel(self):
		self.close()
		
def main(session, **kwargs):
	session.open(speedtest)

def Plugins(**kwargs):
	return PluginDescriptor(name=_("SpeedTest"), description=_("SpeedTest"), where = [PluginDescriptor.WHERE_PLUGINMENU], icon="plugin.png", fnc=main)